#define FROM_ASM
#include "rtos.h"

.global sort_array
.global jack
.global null_call
.global tgt_function
.global get_time
.section	.kernelstuff.t,"ax",@progbits

null_call:
    rtsd    r15, 8
    nop

.text
.align 4
tgt_function:
    brai    get_time

.global region_change_timer
.align 4
region_change_timer:
    get     r9, rfsl1
    get     r6, rfsl1
    addi    r3, r0, region_2
    brai    REGION_CHANGE

.align 4
region_2:
    get     r7, rfsl1
    brai    bounce

bounce:
    # Calculate the region change time
    rsub    r9, r9, r6
    rsub    r6, r6, r7
    rtsd    r15, 8
    rsub    r3, r9, r6 
    
.align 4
jack:
    # hardware 0xd  software 0xb
    lwi     r3, r0, sort_array
    addk    r5, r3, r5
    rtsd    r15, 8
    or      r0, r0, r0

    # hardware 0xd  software 0xd
    lwi     r3, r0, sort_array
    nop
    nop
    addk    r5, r3, r5
    rtsd    r15, 8
    or      r0, r0, r0

    # hardware 0xd  software 0xc
    lwi     r3, r0, sort_array
    nop
    addk    r5, r3, r5
    rtsd    r15, 8
    or      r0, r0, r0

    addk    r4, r0, r0
    addk    r5, r4, r0
0:
    #lwi     r3, r4, sort_array
    addk    r5, r5, r3
    swi     r5, r4, sort_array
    addik   r4, r4, 4
    xori    r18, r4, 200
    bnei    r18, 0b

    rtsd    r15, 8
    or      r0, r0, r0



    beqi r0, foo

    nop
    nop
    nop
    nop
    nop

foo:
    swi r0, r0, sort_array
    lwi r3, r0, sort_array + 4
    rtsd r15, 8
    nop

.global test_chain
.align 8
test_chain:
    .long   0f
    .long   0xa
    addi    r3, r1, 100
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0xb
    addi    r3, r1, 3312100
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0xc
    addi    r3, r1, 3312100
    addi    r4, r3, 26
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0xa
    bslli   r3, r3, 17
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0xa
    bsrai   r3, r3, 17
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0xb
    addk    r4, r3, r0
    bsra    r3, r3, r4
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0xa
    mul     r4, r3, r3
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0xb
    addik   r3, r0, 122
    muli    r4, r3, 266
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0xd
    addik   r3, r0, 1223657
    muli    r4, r3, 266477358
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0x19
    # Software 6 cycles too fast
    addik   r3, r0, 0x12345678
    addik   r5, r0, 0x45678901
    mul     r4, r3, r5
    add     r3, r4, r5
    mul     r4, r3, r5
    add     r3, r4, r5
    mul     r4, r3, r5
    add     r3, r4, r5
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0x2e
    # Software 2 cycles too fast
    addik   r3, r0, 1223657
    addik   r4, r0, 1234
    idiv    r4, r3, r4
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0x17
    # Software 6 cycles too fast
    addik   r3, r0, 0x12345678
    addik   r5, r0, 0x45678901
    mul     r4, r3, r5
    mul     r4, r4, r5
    mul     r4, r4, r3
    add     r3, r4, r5
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0x55
    # Software 8 cycles too fast
    addik   r5, r0, 1229365745
    addik   r3, r0, 12
    idiv    r4, r3, r5
    idiv    r4, r4, r5
    add     r3, r4, r0
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0x1a
    # Software 8 cycles too fast
    addik   r3, r0, 0x12345678
    addik   r5, r0, 0x45678901
    mul     r4, r3, r5
    mul     r4, r4, r5
    mul     r4, r4, r3
    mul     r4, r4, r3
    add     r3, r4, r5
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0x79
    # Software 12 cycles too fast
    addik   r5, r0, 1229365745
    addik   r3, r0, 12
    idiv    r4, r3, r5
    idiv    r4, r4, r5
    idiv    r4, r4, r5
    add     r3, r4, r0
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0x11
    addik   r3, r0, 0x12345678
    addik   r5, r0, 0x45678901
    mul     r4, r3, r5
    mul     r6, r3, r5
    mul     r7, r3, r5
    add     r3, r4, r5
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0x19
    # Software 3 cycles too fast
    addik   r3, r0, 0x12345678
    addik   r5, r0, 0x45678901
    mul     r4, r3, r5
    nop
    add     r3, r4, r5
    mul     r4, r3, r5
    nop
    add     r3, r4, r5
    mul     r4, r3, r5
    nop
    add     r3, r4, r5
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0x19
    # Software 0 cycles too fast
    addik   r3, r0, 0x12345678
    addik   r5, r0, 0x45678901
    mul     r4, r3, r5
    nop
    nop
    add     r3, r4, r5
    mul     r4, r3, r5
    nop
    nop
    add     r3, r4, r5
    mul     r4, r3, r5
    nop
    nop
    add     r3, r4, r5
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0x10
    bslli   r3, r3, 1
    bsrli   r3, r3, 1
    bslli   r3, r3, 1
    bsrli   r3, r3, 1
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0xc
    brid    1f
    nop
    nop
    nop
1:
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0xf
    mul     r3, r4, r0
    beqid   r3, 1f
    nop
    nop
    nop
1:
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0xc
    bri     1f
    nop
    nop
    nop
1:
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0xf
    mul     r3, r4, r0
    beqi    r3, 1f
    nop
    nop
    nop
1:
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0x11
    mul     r3, r4, r0
    nop
    nop
    nop
    nop
    beqi    r3, 1f
    nop
    nop
    nop
1:
    rtsd    r15, 8
    or      r0, r0, r0

.align 8
0:
    .long   0f
    .long   0x11
    mul     r3, r4, r0
    nop
    nop
    nop
    nop
    beqid   r3, 1f
    nop
    nop
    nop
1:
    rtsd    r15, 8
    or      r0, r0, r0


.align 8
0:
    .long   0f
    .long   0x3c
    addi    r4, r0, 1234
    bslli   r3, r3, 1
    bsrli   r3, r3, 1
    mul     r3, r3, r4
    bslli   r3, r3, 1
    idiv    r3, r3, r4
    bsrli   r3, r3, 1
    rsub    r5, r3, r4
    addik   r5, r5, 12345
    muli    r3, r5, 32
    rtsd    r15, 8
    muli    r5, r5, 38

.align 8
0:
    .long   0f
    .long   0x46
    addi    r4, r0, 1234
    bslli   r3, r3, 1
    bsrli   r3, r3, 1
    mul     r3, r3, r4
    bslli   r3, r3, 1
    idiv    r3, r3, r4
    bnei    r4, 1f
2:
    bsrli   r3, r3, 1
    rsub    r5, r3, r4
    addik   r5, r5, 12345
    muli    r3, r5, 32
    rtsd    r15, 8
    muli    r5, r5, 38

1:  
    mul     r3, r3, r4
    bslli   r3, r3, 1
    bneid   r3, 2b
    idiv    r3, r3, r4
    bri     2b

.align 8
0:
    .long   0f
    .long   0x47
    addi    r4, r0, 1234
    bslli   r3, r3, 1
    bsrli   r3, r3, 1
    mul     r3, r3, r4
    bslli   r3, r3, 1
    idiv    r3, r3, r4
    bneid   r4, 1f
2:
    bsrli   r3, r3, 1
    rsub    r5, r3, r4
    addik   r5, r5, 12345
    muli    r3, r5, 32
    rtsd    r15, 8
    muli    r5, r5, 38

1:  
    mul     r3, r3, r4
    bslli   r3, r3, 1
    beqid   r3, 2b
    idiv    r3, r3, r4
    bri     2b

.align 8
0:
    .long   0f
    .long   0x46
    addi    r4, r0, 1234
    bslli   r3, r3, 1
    bsrli   r3, r3, 1
    mul     r3, r3, r4
    bslli   r3, r3, 1
    idiv    r3, r3, r4
    bneid   r4, 1f
2:
    bslli   r3, r3, 1
    rsub    r5, r3, r4
    addik   r5, r5, 12345
    muli    r3, r5, 32
    rtsd    r15, 8
    muli    r5, r5, 38

1:  
    mul     r3, r3, r4
    bslli   r3, r3, 1
    beqid   r3, 2b
    add     r3, r3, r4
    bri     2b

.align 8
0:
    .long   0f
    .long   0x0f
    get     r3, rfsl0
    add     r4, r3, r0
    get     r3, rfsl1
    add     r4, r3, r4
    rtsd    r15, 8
    nop

.align 8
0:
    .long   0f
    .long   0x0d
    addi    r3, r0, scratch
    swi     r3, r3, 0
    rtsd    r15, 8
    nop

.align 8
0:
    .long   0f
    .long   0x0e
    addi    r3, r0, scratch
    swi     r3, r3, 0
    lwi     r4, r3, 0
    rtsd    r15, 8
    nop

.align 8
0:
    .long   0f
    .long   0x10
    addi    r3, r0, scratch
    swi     r3, r3, 0
    lwi     r4, r3, 0
    swi     r3, r3, 0
    rtsd    r15, 8
    nop

.align 8
0:
    .long   0f
    .long   0x11
    addi    r3, r0, scratch
    swi     r3, r3, 0
    lwi     r4, r3, 0
    swi     r3, r3, 0
    lwi     r4, r3, 0
    rtsd    r15, 8
    nop

.align 8
0:
    .long   0f
    .long   0x13
    addi    r3, r0, scratch
    swi     r3, r3, 0
    swi     r3, r3, 0
    swi     r3, r3, 0
    swi     r3, r3, 0
    rtsd    r15, 8
    nop

.align 8
0:
    .long   0f
    .long   0x17
    addi    r3, r0, scratch
    swi     r3, r3, 0
    swi     r3, r3, 0
    swi     r3, r3, 0
    swi     r3, r3, 0
    lwi     r4, r3, 0
    add     r3, r4, r3
    rtsd    r15, 8
    nop

.align 8
0:
    .long   0       # FINAL ENTRY
    .long   0x9
    rtsd    r15, 8
    or      r0, r0, r0

.bss
scratch:
    .space  1024




